/* XNS Utility Script */

const LT = {}, LTE = {}, EQ = {}, LGT = {}, GT = {}, GTE = {}
const AND = {}, OR = {}

function ineq(num0, comp0, num1) {
   var in_flag = 1
   /* 
   in_flag == 2:  unconditionally true
   in_flag == 1:  true so far, unconfirmed
   in_flag == 0:  false so far, unconfirmed
   in_flag == -1:  unconditionally false
   */
   var in_loop = 0
   var left = null, right = null, op = null, result = null
   for (in_loop = 1; (in_loop < arguments.length)&&(in_flag < 2)&&(in_flag > -1); in_loop+=2) {
      left = arguments[in_loop - 1]
      right = arguments[in_loop + 1]
      op = arguments[in_loop]
      result = left.compareTo(right)

      switch (true) {
/* The goal of each loop through is to find a condition which returns false.  In this situation, 
   we can set the in_flag to 0.

An OR condition means we can add one to in_flag.  An AND condition means that if it is currently 
   false, we must end our search.

Because NaN does not compare well to other numbers, I explicitly must state conditions which 
   would pass LTE, LGT and GTE, and then negate those results.

*/

         case ((op == LT)&&(result != -1)):
         case ((op == LTE)&&( !((result == 0)||(result == -1)) )):
         case ((op == EQ)&&(result != 0)):
         case ((op == LGT)&&( !((result == -1)||(result == 1)) )):
         case ((op == GT)&&(result != 1)):
         case ((op == GTE)&&( !((result == 0)||(result == 1)) )):
         in_flag = 0
         break;

         case (op == OR):
         in_flag++
         break;

         case (op == AND):
         if (in_flag < 1) {
            in_flag = -1
            }
         break;

         default:
         }

      }
   var response = false
   if (in_flag > 0) {
      response =  true
      }
   return response
   }

var returnTrue = function() {
   return true
   }

var returnFalse = function() {
   return false
   }

var returnFalseIfNaN = function() {
   return (this.compareTo(0) < 2)
// Numbers will always return -1, 0, or 1 for compareTo, so for numbers this returns true.
// NaN is not less than 2, so for NaN this returns false.
// It is inadvisable to use this function outside of the Number XNS type.
   }

function isXNSNaN(arg) {
   var type = typeof arg
   switch (type) {
      case "number":
      case "string":
      return isNaN(arg)

      case "object":
      return ((typeof XNS_Types[arg.xnsType] != "boolean")||(XNS_Types[arg.xnsType] != true))
/*  The first checks to see if that type has been registered.  The second checks to see if that type is active.  The third 
checks a specific property of the number which the script has set.

There are three special xnsType reserved values:  "+Infinity", "-Infinity", and "NaN".  For the first two, XNS_Types = true.
For the last, XNS_Types = false.
*/
      break;

      default:
      }
   return true
   }

function XNS_Convert_Types(arg1, arg2) {
/* This function compares the properties and facts about the arguments and attempts to convert them all to a common type.
  It returns a new array whose numbered properties (this[0], this[1], etc.) correspond to the arguments submitted, all of 
  a common type.  

We name our conversion functions typeName._fromAltTypeName.  For instance, to convert from a 
Number to a BigDecimal, we would have Number._toBigDecimal(that).   */
   }

/*
function functionArguments() {
   var args = [], funcName = "functionArguments"
   for (var k = 0; k < arguments.length; k++) {
      args[k] = arguments[k]
      if (typeof args[k].toLiteralString == "function") {
         args[k] = args[k].toLiteralString()
         }
      }
   args.callee = arguments.callee
   args.caller = arguments.caller
   this.getLiteral = function() {
      return "new " + funcName + "(" + args.join(",") + ")"
      }
   this.getArguments = function() {
      return args
      }
   }

The above is a template function for allowing an object to return a copy of its constructor function's arguments, or
 a string to reconstruct the object from scratch.  If an argument requires a special literal presentation within a string
 (for instance, a string must be in quotes), the argument is expected to provide a toLiteralString() method.

Be sure to change the word functionArguments in both instances to the appropriate function name.

This will probably break on Object() objects.  It's a bit difficult to specify a prototyped-in method of Object that will
 not affect all objects and values in the language.
*/

String.prototype.toLiteralString = function() {
   var response = this.replace(/\\/g, "\\\\")
   response = response.replace(/\"/g, '\\"')
   response = response.replace(/\'/g, "\\'")
   return "'" + response + "'"
   }

Array.prototype.toLiteralString = function() {
   var args = []
   for (var property in this) {
      if (typeof this[property].toLiteralString == "function") {
         args[property] = this[property].toLiteralString()
         } else {
         args[property] = this[property]
         }
      }
   return "[" + args.join(",") + "]"
   }

Date.prototype.toLiteralString = function() {
   return "new Date(" + this * 1 + ")"
   }

Error.prototype.toLiteralString = function() {
   return "new Error('" + this.message.toLiteralString() + "')"
   }

Number.prototype.toLiteralString = Number.prototype.toString

var XNS_Types = []
XNS_Types["+Infinity"] = true
XNS_Types["-Infinity"] = true
XNS_Types["NaN"] = false

const xmlns_math = "http://www.w3.org/1998/Math/MathML"